<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Strings for component "assignsubmission_dta", language "en"
 *
 * @package   assignsubmission_dta
 * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 * @copyright Gero Lueckemeyer and student project teams
 */

// General.
$string["pluginname"] = "Dockerized Testing Agent (DTA)";
$string["enabled"] = $string["pluginname"];

// Dialog field labels.
$string["submission_label"] = "DTA submission configuration or zip-packed project";
$string["submission_label_help"] = "Either upload a single textfile containing one DTA URI pointing to the repository with your submission or pack your project as zip and upload it directly. Using the textfile you can additionally add as many unified-ticketing URI (one per line) as you wish for feedback into one or more ticketsystems.";
$string["submission_settings_label"] = "DTA test configuration";
$string["submission_settings_label_help"] = "single text file with  DTA test URI";
$string["enabled_help"] = "If enabled, you will have to upload a textfile containing a valid DTA URI pointing to the repository with your test logic and defining a docker image on dockerhub used as testrunner. Your students will have to either upload their code in a zip archive resembling the expected repository structure or as well by providing a textifle with a valid DTA URI pointing to the repository with their submission logic";

// Content.
$string["tests_successful"] = " successful";
$string["failures"] = " failure";
$string["compilation_errors"] = " compilation error";
$string["unknown_state"] = " with unknown state";
$string["success_competencies"] = "Successfully tested competency profile ";
$string["summary"] = "Summary";
$string["total_items"] = "Total items";
$string["success_rate"] = "Success rate";
$string["details"] = "Details";
$string["competencies"] = "Competencies";
$string["package_name"] = "Package Name";
$string["unit_name"] = "Unit Name";
$string["test_name"] = "Test Name";
$string["status"] = "Status";
$string["failure_type"] = "Failure Type";
$string["failure_reason"] = "Failure Reason";
$string["line_no"] = "Line Number";
$string["col_no"] = "Column Number";
$string["pos"] = "Position";
$string["stacktrace"] = "Stack Trace";

// Comeptencies.
$string["comp_statement"] = "Statement";
$string["comp_block"] = "Block";
$string["comp_flow"] = "Flow of Control";
$string["comp_loop"] = "Repetition";
$string["comp_const"] = "Constant";
$string["comp_var"] = "Variable";
$string["comp_type"] = "Type";
$string["comp_datastructure"] = "Data Structure";
$string["comp_interface"] = "Interface";
$string["comp_unit"] = "Unit of Code";
$string["comp_proc_usage"] = "Procedure Usage";
$string["comp_proc_sign"] = "Procedure Signature";
$string["comp_library"] = "Library Usage";
$string["comp_ext_api"] = "External API Usage";
$string["comp_simple"] = "Simplicity";
$string["comp_abstraction"] = "Abstraction";

// Competencies for index calculation.
$string["comp0"] = $string["comp_statement"];
$string["comp1"] = $string["comp_block"];
$string["comp2"] = $string["comp_flow"];
$string["comp3"] = $string["comp_loop"];
$string["comp4"] = $string["comp_const"];
$string["comp5"] = $string["comp_var"];
$string["comp6"] = $string["comp_type"];
$string["comp7"] = $string["comp_datastructure"];
$string["comp8"] = $string["comp_interface"];
$string["comp9"] = $string["comp_unit"];
$string["comp10"] = $string["comp_proc_usage"];
$string["comp11"] = $string["comp_proc_sign"];
$string["comp12"] = $string["comp_library"];
$string["comp13"] = $string["comp_ext_api"];
$string["comp14"] = $string["comp_simple"];
$string["comp15"] = $string["comp_abstraction"];

// Competency explanations.
$string["comp_statement_expl"] = "formulate a syntactically correct statement that contributes to the solution of the given problem.";
$string["comp_block_expl"] = "structure code into syntactically correct small unnamed units that contribute to the solution of the given problem.";
$string["comp_flow_expl"] = "formulate syntax elements guiding the control flow such that it contributes to the solution of the given problem.";
$string["comp_loop_expl"] = "use syntax elements repeating statements such that it contributes to the solution of the given problem.";
$string["comp_const_expl"] = "identify and syntactically correctly define constants that contribute to the understanding and solution of the given problem.";
$string["comp_var_expl"] = "identify and syntactically correctly define variables that contribute to the solution of the given problem.";
$string["comp_type_expl"] = "define and/or choose appropriate data types for data elements such that they contribute to the solution of the given problem.";
$string["comp_datastructure_expl"] = "define and/or choose appropriate data structures for data elements such that they contribute to the solution of the given problem.";
$string["comp_interface_expl"] = "define and use interfaces for larger units of code such that it contributes to the solution of the given problem.";
$string["comp_unit_expl"] = "define and larger units of code such that it contributes to the solution of the given problem.";
$string["comp_proc_usage_expl"] = "use existing named structure blocks with a pre-defined behavior and signature such that it contributes to the solution of the given problem.";
$string["comp_proc_sign_expl"] = "define named structure blocks with a pre-defined behavior and signature such that it contributes to the solution of the given problem.";
$string["comp_library_expl"] = "use existing larger collections of named structure blocks with a pre-defined behavior and signature such that it contributes to the solution of the given problem.";
$string["comp_ext_api_expl"] = "use standardized existing external collections of named structure blocks with a pre-defined behavior and signature such that it contributes to the solution of the given problem.";
$string["comp_simple_expl"] = "create a simple solution of the given problem.";
$string["comp_abstraction_expl"] = "create a sufficiently abstract solution for the given problem.";

// Competency explanations for index calculations.
$string["comp_expl0"] = $string["comp_statement_expl"];
$string["comp_expl1"] = $string["comp_block_expl"];
$string["comp_expl2"] = $string["comp_flow_expl"];
$string["comp_expl3"] = $string["comp_loop_expl"];
$string["comp_expl4"] = $string["comp_const_expl"];
$string["comp_expl5"] = $string["comp_var_expl"];
$string["comp_expl6"] = $string["comp_type_expl"];
$string["comp_expl7"] = $string["comp_datastructure_expl"];
$string["comp_expl8"] = $string["comp_interface_expl"];
$string["comp_expl9"] = $string["comp_unit_expl"];
$string["comp_expl10"] = $string["comp_proc_usage_expl"];
$string["comp_expl11"] = $string["comp_proc_sign_expl"];
$string["comp_expl12"] = $string["comp_library_expl"];
$string["comp_expl13"] = $string["comp_ext_api_expl"];
$string["comp_expl14"] = $string["comp_simple_expl"];
$string["comp_expl15"] = $string["comp_abstraction_expl"];

// Warnings.
$string["no_testfile_warning"] = "Submission type is \"Dockerized Testing Agent\" but no configuration file uploaded";

// Error messages.
$string["backendHost_not_set"] = "The Dockerized Testing Agent backend URL is not configured";
$string["no_submissionfile_warning"] = "Submission type is \"Dockerized Testing Agent\" but no configuration file or submission archive uploaded";
$string["http_client_error_msg"] = "A client error occured (HTTP 4xx)";
$string["http_server_error_msg"] = "A server error occured (HTTP 5xx)";
$string["http_unknown_error_msg"] = "An unknown HTTP error occured on backend transfer";

// Admin settings.
$string["default"] = "Enabled by default";
$string["default_help"] = "If set, this submission method will be enabled by default for all new assignments.";
$string["backendHost"] = "Backend Server Address";
$string["backendHost_help"] = "Address/Name and Port of backend server";

// Database field descriptions for privacy API.
$string["privacy:metadata:core_files"] = "Moodle core files.";
$string["privacy:metadata:assignsubmission_dta_summary:assignmentid"] = "ID of the assignment";
$string["privacy:metadata:assignsubmission_dta_summary:submissionid"] = "ID of the submission";
$string["privacy:metadata:assignsubmission_dta_summary:timestamp"] = "Date and time of the submission";
$string["privacy:metadata:assignsubmission_dta_summary"] = "Stack trace of the compilation and test if major problems occur";
$string["privacy:metadata:assignsubmission_dta_summary:successful_competencies"] = "List of the successfully tested competencies";
$string["privacy:metadata:assignsubmission_dta_summary:tested_competencies"] = "List of the tested competencies";
$string["privacy:metadata:assignsubmission_dta_summary"] = "Summary of Dockerized Test Agent (DTA) results";
$string["privacy:metadata:assignsubmission_dta_result:package_name"] = "Package name of individual test";
$string["privacy:metadata:assignsubmission_dta_result:class_name"] = "Class name of individual test";
$string["privacy:metadata:assignsubmission_dta_result:name"] = "Name of individual test";
$string["privacy:metadata:assignsubmission_dta_result:state"] = "State of individual test";
$string["privacy:metadata:assignsubmission_dta_result:failure_type"] = "Failure type of individual test";
$string["privacy:metadata:assignsubmission_dta_result:failure_reason"] = "Failure reason of individual test";
$string["privacy:metadata:assignsubmission_dta_result:stacktrace"] = "Stack trace of failed compilation or individual test";
$string["privacy:metadata:assignsubmission_dta_result:column_number"] = "Column number of failed individual compilation or test";
$string["privacy:metadata:assignsubmission_dta_result:line_number"] = "Line number of failed individual compilation or test";
$string["privacy:metadata:assignsubmission_dta_result:position"] = "Position of failed individual compilation or test";
$string["privacy:metadata:assignsubmission_dta_result"] = "Individual Dockerized Test Agent (DTA) results";
$string["privacy:metadata:dta_backend"] = "Dockerized Test Agent (DTA) backend ReST web service";
